//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
	//     
	FnWhichPlayer = 1;

	//   
	FpXBitmap = new Graphics::TBitmap;
	FpXBitmap->Width = ClientWidth/3 - 2;
	FpXBitmap->Height = ClientHeight/3 - 2;

	//    
	FpXBitmap->Canvas->Brush->Color = Color;

	TRect r;
	r.Left = 0;
	r.Top = 0;
	r.Right = FpXBitmap->Width;
	r.Bottom = FpXBitmap->Height;

	FpXBitmap->Canvas->FillRect( r);

	FpYBitmap = new Graphics::TBitmap;
	FpYBitmap->Width = ClientWidth/3 - 2;
	FpYBitmap->Height = ClientHeight/3 - 2;

	//    
	FpYBitmap->Canvas->Brush->Color = Color;
	FpYBitmap->Canvas->FillRect( r);

	//   X ()
	FpXBitmap->Canvas->MoveTo(0,0);
	FpXBitmap->Canvas->LineTo(FpXBitmap->Width, FpXBitmap->Height);
	FpXBitmap->Canvas->MoveTo(FpXBitmap->Width,0);
	FpXBitmap->Canvas->LineTo(0, FpXBitmap->Height);

	//   Y ()
	FpYBitmap->Canvas->Ellipse(0,0,FpYBitmap->Width,FpYBitmap->Height);
}

__fastcall TForm1::~TForm1(void)
{
   delete FpXBitmap;
   delete FpYBitmap;
}


void TForm1::ResetBoard(void)
{
  //   
  for ( int i=0; i<3; ++i )
    for ( int j=0; j<3; ++j )
      FnGameBoard[i][j] = 0;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::FormPaint(TObject *Sender)
{
    //      
	Canvas->MoveTo( ClientWidth/3,0 );
	Canvas->LineTo( ClientWidth/3,ClientHeight );
	Canvas->MoveTo( (2*ClientWidth)/3,0);
	Canvas->LineTo( (2*ClientWidth)/3, ClientHeight );

	//  
	Canvas->MoveTo( 0, ClientHeight/3 );
	Canvas->LineTo( ClientWidth, ClientHeight/3 );
	Canvas->MoveTo( 0, (2*ClientHeight)/3 );
	Canvas->LineTo( ClientWidth, (2*ClientHeight)/3 );

	//    

	for ( int i=0; i<3; ++i )
		for ( int j=0; j<3; ++j )
		{
			int nXPos = (ClientWidth/3)*j + 1;
			int nYPos = (ClientHeight/3)*i + 1;
			//    - 
			if ( FnGameBoard[i][j] == 1 )
			{
				Canvas->Draw(nXPos, nYPos, FpXBitmap );
			}

			else
			//    - 
			if (FnGameBoard[i][j] == 2 )
			{
				Canvas->Draw(nXPos, nYPos, FpYBitmap );
			}
		}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormMouseDown(TObject *Sender, TMouseButton Button,
	TShiftState Shift, int X, int Y)
{
	int nRow;
	int nCol;

	// ,   
	if ( X < ClientWidth/3 )
		nCol = 0;
	else
		if ( X < (2*ClientWidth)/3 )
			nCol = 1;
		else
			nCol = 2;

	if ( Y < ClientHeight/3 )
		nRow = 0;
	else
		if ( Y < (2*ClientHeight)/3 )
			nRow = 1;
		else
			nRow = 2;

	// ,    
	if ( FnGameBoard[nRow][nCol] != 0 )
	{
		MessageBeep(0);
	}
	else //  -    
	{
		FnGameBoard[nRow][nCol] = FnWhichPlayer;

		//  
		if ( FnWhichPlayer == 1 )
			FnWhichPlayer = 2;
		else
			FnWhichPlayer = 1;
			Invalidate();

			// ,    
			if ( CheckForWinner() )
			{
				ResetBoard();
				FnWhichPlayer = 1;
				Invalidate();
			}
	}
}

BOOL TForm1::CheckForWinner(void)
{
	int nWinner;

	for ( int nPlayer = 1; nPlayer<3; ++nPlayer )
	{
		//  
		for ( int nRow = 0; nRow<3; ++nRow)
		{
			// ,    
			nWinner = nPlayer;

			//   .     
			//   ,    
			for (int nCol = 0; nCol<3; ++nCol )
				if ( FnGameBoard[nRow][nCol] != nPlayer )
					nWinner = 0;

			if ( nWinner != 0 )
			{
				String s = " " + String(nWinner) + " ";
				MessageBox(NULL, s.c_str(), "", MB_OK );
				return true;
			}
		}

		//    
		for ( int nCol = 0; nCol<3; ++nCol )
		{
			// ,    
			nWinner = nPlayer;

			//   .     
			//   ,    

			for ( int nRow = 0; nRow<3; ++nRow )
				if ( FnGameBoard[nRow][nCol] != nPlayer )
					nWinner = 0;

			if ( nWinner != 0 )
			{
				String s = " " + String(nWinner) + " ";
				MessageBox(NULL, s.c_str(), "", MB_OK );
				return true;
			}
		}

		// ,  

		if ( FnGameBoard[0][0] == nPlayer &&
			FnGameBoard[1][1] == nPlayer &&
			FnGameBoard[2][2] == nPlayer )
		{
				String s = " " + String(nPlayer) + " ";
				MessageBox(NULL, s.c_str(), "", MB_OK );
				return true;
		}

		if ( FnGameBoard[0][2] == nPlayer &&
			FnGameBoard[1][1] == nPlayer &&
			FnGameBoard[2][0] == nPlayer )
		{
				String s = " " + String(nPlayer) + " ";
				MessageBox(NULL, s.c_str(), "", MB_OK );
				return true;
		}

	}

	//   , ,    
	//   (   )
	for ( int nRow = 0; nRow<3; ++nRow )
	{
		for ( int nCol = 0; nCol <3; ++nCol )
			if ( FnGameBoard[nRow][nCol] == 0 )
				return false;
	}

	//    
	MessageBox(NULL, " !", " ", MB_OK );
	return true;
}
//---------------------------------------------------------------------------